unit LoksimUtils;

interface

uses
  SysUtils;

const
	KEY_SIFA              = 1;
	KEY_INDUSI            = 2;
	KEY_FREIINDUSI        = 3;
	KEY_LZB               = 4;
	KEY_LICHT             = 5;
	KEY_FERNLICHT         = 6;
	KEY_HAUPTSCHALTER     = 7;
	KEY_PFIFF             = 8;
	KEY_GLOCKE            = 9;
	KEY_AFBVZIELANZEIGEN  = 10;
	KEY_TUEREN            = 11;
	KEY_SANDEN            = 12;
	KEY_AFB               = 13;
	KEY_STUP              = 14;
	KEY_STDOWN            = 15;
	KEY_STLEFT            = 16;
	KEY_STRIGHT           = 17;
	KEY_BREMSEN0          = 18;
	KEY_BREMSEN1          = 19;
	KEY_BREMSEN2          = 20;
	KEY_BREMSEN3          = 21;
	KEY_BREMSEN4          = 22;
	KEY_BREMSEN5          = 23;
	KEY_BREMSEN6          = 24;
	KEY_BREMSEN7          = 25;
	KEY_BREMSEN8          = 26;
	KEY_BREMSEN9          = 27;
	KEY_SPEICHERBREMSE    = 28;
	KEY_STNULLSTELLUNG    = 29;
	KEY_ZUGKRAFTSTELLER   = 30;
	KEY_BEFEHLINDUSI      = 31;
	KEY_HALTANSAGE        = 32;
	KEY_BUEGEL            = 33;


//OleParameter
const
  cParamSeparator = '|';
  cKeyValueSeparator = '=';


  cLOK_COMMON_ACTSPEED = 'LOK.COMMON.ACTSPEED';
  cLOK_COMMON_MAXSPEED = 'LOK.COMMON.MAXSPEED';
  
  //Anzeige ist Bool
	cLOK_ANZEIGE_SCHLEUDERN = 'LOK.ANZEIGE.SCHLEUDERN';
	cLOK_ANZEIGE_SANDEN = 'LOK.ANZEIGE.SANDEN';
	cLOK_ANZEIGE_HAUPTSCHALTER = 'LOK.ANZEIGE.HAUPTSCHALTER';
	cLOK_ANZEIGE_SIFA = 'LOK.ANZEIGE.SIFA';
	cLOK_ANZEIGE_INDUSIHZ1000 = 'LOK.ANZEIGE.INDUSIHZ1000';
	cLOK_ANZEIGE_INDUSIHZ500 = 'LOK.ANZEIGE.INDUSIHZ500';
	cLOK_ANZEIGE_INDUSI95 = 'LOK.ANZEIGE.INDUSI95';
	cLOK_ANZEIGE_INDUSI75 = 'LOK.ANZEIGE.INDUSI75';
	cLOK_ANZEIGE_INDUSI60 = 'LOK.ANZEIGE.INDUSI60';
	cLOK_ANZEIGE_INDUSIBEFEHL = 'LOK.ANZEIGE.INDUSIBEFEHL';
	cLOK_ANZEIGE_LZBBETRIEB = 'LOK.ANZEIGE.LZBBETRIEB';
	cLOK_ANZEIGE_LZBG = 'LOK.ANZEIGE.LZBG';
	cLOK_ANZEIGE_LZBU = 'LOK.ANZEIGE.LZBU';
	cLOK_ANZEIGE_LZBENDE = 'LOK.ANZEIGE.LZBENDE';
	cLOK_ANZEIGE_SCHNELLBREMSUNG = 'LOK.ANZEIGE.SCHNELLBREMSUNG';
	cLOK_ANZEIGE_MAGNETBREMSE = 'LOK.ANZEIGE.MAGNETBREMSE';
	cLOK_ANZEIGE_HOHEABBREMSUNGVORH = 'LOK.ANZEIGE.HOHEABBREMSUNGVORH';
	cLOK_ANZEIGE_TUER1 = 'LOK.ANZEIGE.TUER1';
	cLOK_ANZEIGE_TUER2 = 'LOK.ANZEIGE.TUER2';
	cLOK_ANZEIGE_TUERVERRIEGELUNG = 'LOK.ANZEIGE.TUERVERRIEGELUNG';
	cLOK_ANZEIGE_LICHT = 'LOK.ANZEIGE.LICHT';
	cLOK_ANZEIGE_MESS = 'LOK.ANZEIGE.MESS';
	cLOK_ANZEIGE_AFB = 'LOK.ANZEIGE.AFB';
	cLOK_ANZEIGE_TRAKTIONGESPERRT = 'LOK.ANZEIGE.TRAKTIONGESPERRT';
	cLOK_ANZEIGE_FEDERSPEICHERBREMSE = 'LOK.ANZEIGE.FEDERSPEICHERBREMSE';
	cLOK_ANZEIGE_ZUGKRAFTSTELLERAKTIV = 'LOK.ANZEIGE.ZUGKRAFTSTELLERAKTIV';
	cLOK_ANZEIGE_BUEGELPANTO = 'LOK.ANZEIGE.BUEGELPANTO';

//Instrument ist double
	cLOK_INSTRUMENT_TACHO = 'LOK.INSTRUMENT.TACHO';
	cLOK_INSTRUMENT_LZBVZIEL = 'LOK.INSTRUMENT.LZBVZIEL';
	cLOK_INSTRUMENT_LZBVZIELABSTANDDIGITAL = 'LOK.INSTRUMENT.LZBVZIELABSTANDDIGITAL';
	cLOK_INSTRUMENT_LZBVZIELABSTANDBALKEN = 'LOK.INSTRUMENT.LZBVZIELABSTANDBALKEN';
	cLOK_INSTRUMENT_AFB = 'LOK.INSTRUMENT.AFB';
	cLOK_INSTRUMENT_BREMSDRUCK = 'LOK.INSTRUMENT.BREMSDRUCK';
	cLOK_INSTRUMENT_BREMSZYLINDERDRUCK = 'LOK.INSTRUMENT.BREMSZYLINDERDRUCK';
	cLOK_INSTRUMENT_2BREMSZYLINDERDR = 'LOK.INSTRUMENT.2BREMSZYLINDERDR';
	cLOK_INSTRUMENT_DYNBREMSSTUFE = 'LOK.INSTRUMENT.DYNBREMSSTUFE';
	cLOK_INSTRUMENT_ISTSTUFE = 'LOK.INSTRUMENT.ISTSTUFE';
	cLOK_INSTRUMENT_SOLLSTUFE = 'LOK.INSTRUMENT.SOLLSTUFE';
	cLOK_INSTRUMENT_MOTORSTROM = 'LOK.INSTRUMENT.MOTORSTROM';
	cLOK_INSTRUMENT_OBERSTROM = 'LOK.INSTRUMENT.OBERSTROM';
	cLOK_INSTRUMENT_KRAFT = 'LOK.INSTRUMENT.KRAFT';
	cLOK_INSTRUMENT_ZUGKRAFTSTELLER = 'LOK.INSTRUMENT.ZUGKRAFTSTELLER';
	cLOK_INSTRUMENT_VSOLLSTELLER = 'LOK.INSTRUMENT.VSOLLSTELLER';
	cLOK_INSTRUMENT_FAHRSPANNUNG = 'LOK.INSTRUMENT.FAHRSPANNUNG';

//Double
  cSIM_COMMON_SIMTIME = 'SIM.COMMON.SIMTIME'; //Zeit die in der Simulation vergangen ist in Sekunden


procedure LoksimUtilsAddParam( var ParamString: WideString; const ParamName: WideString);

function  LoksimUtilsGetParamBool( const CodedParamString: WideString; const ParamName: WideString): boolean;

function  LoksimUtilsGetParamFloat( const CodedParamString: WideString; const ParamName: WideString): Double;

implementation

procedure LoksimUtilsAddParam( var ParamString: WideString; const ParamName: WideString);
begin
  if ParamString <> '' then
    ParamString := ParamString + cParamSeparator;
  ParamString := ParamString + ParamName;
end;

function  LoksimUtilsGetParamRawString( const CodedParamString: WideString; const ParamName: WideString): WideString;
var
  PosStart: integer;
  PosEnd: integer;
begin
  Result := '';
  PosStart := Pos( ParamName + cKeyValueSeparator, CodedParamString);
  if PosStart > 0 then
  begin
    Result := Copy( CodedParamString, PosStart + Length( ParamName + cKeyValueSeparator), Length( CodedParamString));
    PosEnd := Pos( cParamSeparator, Result);
    if PosEnd > 0 then
    begin
      Result := Copy( Result, 1, PosEnd - 1);
    end;
  end;
end;

function  LoksimUtilsGetParamBool( const CodedParamString: WideString; const ParamName: WideString): boolean;
var
  S: WideString;
begin
  Result := False;
  S := LoksimUtilsGetParamRawString( CodedParamString, ParamName);
  if S = 'TRUE' then
    Result := True;
end;


function  LoksimUtilsGetParamFloat( const CodedParamString: WideString; const ParamName: WideString): Double;
var
  S: WideString;
  OldDecimalSeparator: char;
begin
  Result := 0;
  S := LoksimUtilsGetParamRawString( CodedParamString, ParamName);
  if S <> '' then
  begin
    OldDecimalSeparator := DecimalSeparator;
    try
      DecimalSeparator := '.';
      Result := StrToFloat( S);
    except
      Result := 0;
    end;
    DecimalSeparator := OldDecimalSeparator;
  end;
end;


end.
